#define _MAIN_C
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include "structs.h"
#include "config.h"

int main(int argc, char **argv) {
	char l_flag = 0;
	char *d_flag = NULL;

	int opt;
	while ((opt = getopt(argc, argv, "hld:")) != -1) {
		switch (opt) {
			case 'l':
				l_flag = 1;
				break;

			case 'd':
				d_flag = optarg;
				break;

			case 'h':
			default:
				printf("kfetch [-hld]\n\t-h Help\n\t-l Dont print logo\n\t-d STR Set STR as distro name\n");
				return 0;
		}
	}

	FETCH fetch = Init();
	if (d_flag != NULL) {
		snprintf(fetch.os_name, sizeof(fetch.os_name), "%s", d_flag);
		GetArt(&fetch, 0);
	}

	size_t j = 0;
	for (size_t i = 0; i < sizeof(CONFIG) / sizeof(PARAMETR); i++) {
		if (CONFIG[i].func == NULL)
			break;

		/* Print ascii logo */
		if (j < fetch.logo_size && !l_flag)
			printf("%s", fetch.logo[j]);

		else if (j >= fetch.logo_size && !l_flag)
			printf("%s", fetch.logo[fetch.logo_size - 1]);

		/* Function exec */
		printf("%s%s", fetch.color, CONFIG[i].par.str0);
		if (CONFIG[i].func(CONFIG[i].par, fetch))
			printf("%s%s", FONT_COLOR, ON_ERROR_STR);

		else {
			if (CONFIG[i].par.str1 != NULL)
				printf(CONFIG[i].par.str1, fetch.color);
		}

		j++;
		printf("\033[0m\n");
	}

	for (; j < fetch.logo_size - 1; j++)
		if (!l_flag)
			printf("%s\n", fetch.logo[j]);

	printf("\033[0m");
	return 0;
}
